#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include <ESP8266mDNS.h>

//Capacitive touch sensor
#define ANALOG_READ_PIN A0 //GPIO 5
#include <CapacitiveSensor.h>


int sensorValue = 0;
int letzteWerte[100];
int niedrigsterWert = 1024;
int idWert = 0;


// IP Addresse wie bei der Feuerwehr!
IPAddress apIP(192, 168, 112, 1);





/// Brauchen wir bald nicht mehr 
int pushButton = D8;
int lastbuttonstate = 0;




int auftrittmillis = 0;
int abtrittmillis = 0;
int auftrittzeiten[20];
int kontaktzeiten[20];


int idx = 0;

String websiteA = "<!doctype html><html lang=en><head><meta charset=utf-8><title>Sensor</title></head><body style='background:#2d2d2d'>"
"<div style='position:fixed;top:10%;left:10%;width:80%;height:80%;color:#ffffff;text-align:left;vertical-align:left;line-height:100%;font-size:300%;font-family:Arial,Helvetica,sans-serif;''> <ul style='list-style-type:none;'> ";
String websiteB = "</ul></div><div style='position:fixed;bottom:0;left:0;width:100%;height:20%;background:#9ade00;color:#00252c;text-align:center;vertical-align:middle;line-height:400%;font-size:400%'> <p><b>Start</b></p> </div> </body></html>";




ESP8266WebServer server(80);

const int led = 13;

void handleRoot() {
  String liste;
  
    int vorherig = 1024;
    int aktuell = 1024;

    liste = liste + "niedrigster: " + niedrigsterWert;
    liste = liste + "<li>";
    for(int i = 0; i < 20; i++) {
      liste = liste + "<ul>" + i + ". Kontakt:" + kontaktzeiten[i] + " ms </ul>";
    }
    liste = liste + "</li>";
  server.send(200, "text/html", websiteA + liste + websiteB);
}



void handleNotFound() {
  handleRoot();
}

void setup(void) {
  pinMode(pushButton, INPUT);
  pinMode(ANALOG_READ_PIN, INPUT);
  pinMode(led, OUTPUT);
  digitalWrite(led, 0);
  Serial.begin(115200);
  WiFi.softAPConfig(apIP, apIP, IPAddress(255, 255, 255, 0));
  WiFi.softAP("Drucksensor");
  Serial.println("");
  
  
  Serial.println("");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());

  if (MDNS.begin("esp8266")) { Serial.println("MDNS responder osestarted"); }

  server.on("/", handleRoot);

  server.onNotFound(handleNotFound);

  server.begin();
  Serial.println("HTTP server eierstarted");
}


int letzterWert = 1024;

void loop(void) {

  
  sensorValue = analogRead(ANALOG_READ_PIN);
//  Serial.println(sensorValue);
 
  letzteWerte[idWert] = sensorValue;
  idWert = (idWert + 1) % 100;
  niedrigsterWert = std::min(sensorValue, niedrigsterWert);

  if(letzterWert >= 300 && sensorValue < 300 )
  {
    auftrittmillis = millis();

    // nur wenn mehr als 30ms, dann Ausgeben
    if((auftrittmillis - abtrittmillis) > 30) {
      Serial.print("Flugphase: ");
      Serial.println(auftrittmillis - abtrittmillis);
    }
  }
  if(letzterWert < 300 && sensorValue >= 300)
  {
    abtrittmillis = millis();
    

    if ((abtrittmillis - auftrittmillis)> 30 ) {
      auftrittzeiten[idx] = auftrittmillis;
      kontaktzeiten[idx] = abtrittmillis - auftrittmillis;
      idx = (idx + 1)%20;

      Serial.print(idx);
      Serial.print(". Bodenkontakt: ");
      Serial.println(abtrittmillis - auftrittmillis);
    }
  }
 
  letzterWert = sensorValue;

  
  delay(20);  // delay in between reads for stability
  server.handleClient();
}
